/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";
var BaseDebugAdapter = (function () {
    function BaseDebugAdapter() {
    }
    BaseDebugAdapter.prototype.registerEventHandler = function (eventHandler) {
        this._eventHandler = eventHandler;
    };
    BaseDebugAdapter.prototype.registerRequestHandler = function (requestHandler) {
        this._requestHandler = requestHandler;
    };
    BaseDebugAdapter.prototype.sendEvent = function (event) {
        if (this._eventHandler) {
            this._eventHandler(event);
        }
    };
    BaseDebugAdapter.prototype.sendRequest = function (command, args, timeout, cb) {
        if (this._requestHandler) {
            this._requestHandler(command, args, timeout, cb);
        }
    };
    return BaseDebugAdapter;
}());
exports.BaseDebugAdapter = BaseDebugAdapter;

//# sourceMappingURL=baseDebugAdapter.js.map
